/*************************************************************
file:
    isql.y
purpose:
    the syntaxer for PL/DMSQL language, prepared for bison/yacc
new features:(compared to DM3's lexical scaner)
    1. -- style comments
    2. c-style comments (can be nested!)
    3. double quoted identifier
    4. string can be merged by "\"
    5. escape char supported in string literial
    6. some SQL-3 features
special notes:
    to generate gramma_tab.h, just type: bison -d gramma.y;
    if need to add some new keyword, follow the steps below:
       1. add a token for the key in the definition sections
          for example: if "XXX" is a new keyword, add it as
             %token XXX
       2. in the lexkeyw.c, increase the NUMBER_OF_KEYWORDS
       3. append a new line in the table of
             lex_keyword_t keytable[]
       4. done
*************************************************************/

%{
import java.io.*;
import java.util.Vector;
import dm.jdbc.DmdbConnection;
%}


%token KW_CONTEXT, KW_REBUILD, KW_SYNC
%token LT_STRING, LT_BINTEGER, LT_INTEGER, LT_IDENTIFIER, LT_BITSTRING, LT_DECIMAL, LP_OP, LT_REAL
%token LT_GLOBAL_VAR
%token KW_ABSOLUTE, KW_ACTION, KW_ADD, KW_AFTER, KW_ALL, KW_ALTER, KW_AND
%token KW_ANY, KW_AS, KW_ASC, KW_ASSIGN, KW_AUTHORIZATION, KW_AVG
%token KW_BACKUP, KW_BEFORE, KW_BEGIN, KW_BETWEEN,  KW_BOUNDARY, KW_BY
%token KW_CALL, KW_CASCADE, KW_CASE, KW_CAST, KW_CHAIN, KW_CHECK, KW_CLOSE
%token KW_COLUMN, KW_COMMIT, KW_COMMITED, KW_COMMITWORK ,KW_COMPILE
%token KW_CONSTRAINT, KW_COUNT, KW_CREATE, KW_CROSS, KW_CURRENT, KW_CURSOR
%token KW_DATABASE, KW_DATAFILE, KW_DEBUG,
%token KW_DECLARE, KW_DECODE, KW_DEFAULT, KW_DEFERRABLE, KW_DELETE, KW_DESC, KW_DISABLE
%token KW_DISCONNECT, KW_DISTINCT, KW_DROP, KW_ENCRYPTION
%token KW_EACH, KW_ELSE, KW_ELSEIF, KW_ENABLE, KW_END, KW_EXCEPTION, KW_EXECUTE
%token KW_EXISTS, KW_EXIT, KW_EXPLAIN, KW_EXTERNAL
%token KW_FALSE, KW_FETCH, KW_FIRST, KW_FOR, KW_FOREIGN, KW_FOUND, KW_FROM, KW_FULL
%token KW_FUNCTION
%token KW_GLOBAL, KW_GOTO, KW_GRANT, KW_GROUP
%token KW_HAVING
%token KW_IDENTIFIED, KW_IF,  KW_IMMEDIATE, KW_IN, KW_INCREASE
%token KW_INDEX, KW_INITIALLY, KW_INSERT, KW_INTO, KW_IS, KW_ISOLATION, KW_ISOPEN
%token KW_JOIN
%token KW_KEY
%token KW_LAST, KW_LEFT, KW_LEVEL, KW_LIKE, KW_LOCAL, KW_LOGIN, KW_LOOP
%token KW_MATCH,  KW_MAX, KW_MIN, KW_MODIFY
%token KW_NEXT, KW_NEW, KW_NOT, KW_NOTFOUND, KW_NOWAIT, KW_NULL,  KW_TOO_MANY_ROWS
%token KW_OF, KW_OLD, KW_ON, KW_ONLY, KW_OPEN, KW_OPTION, KW_OR, KW_ORDER, KW_OUT, KW_OUTER
%token KW_PARTIAL, KW_PENDANT, KW_PRECISION, KW_PRESERVE, KW_PRIMARY, KW_PRINT, KW_PRIOR
%token KW_PRIVILEGES, KW_PROCEDURE, KW_CONNECT
%token KW_READ, KW_REFERENCES, KW_REFERENCING, KW_RELATIVE, KW_RENAME, KW_REPEAT
%token KW_RAISE, KW_REPEATABLE, KW_REPLACE, KW_RESTORE, KW_RESTRICT, KW_RETURN, KW_REVERSE
%token KW_REVOKE, KW_RIGHT, KW_ROLE, KW_ROLLBACK, KW_ROW, KW_ROWCOUNT, KW_ROWNUM, KW_ROWS
%token KW_SAVEPOINT, KW_SCHEMA, KW_SELECT, KW_SERIALIZABLE, KW_SET
%token KW_SOME,  KW_SQL, KW_STATEMENT, KW_SUM
%token KW_TABLE, KW_TEMPORARY,  KW_THEN, KW_TO, KW_TRANSACTION, KW_TRIGGER
%token KW_TRUE, KW_TRUNCATE
%token KW_UNCOMMITED, KW_UNION, KW_UNIQUE, KW_BITMAP, KW_UNTIL, KW_UPDATE, KW_USER
%token KW_VALUES, KW_VARYING, KW_VIEW
%token KW_WHEN, KW_WHERE, KW_WHILE, KW_WITH, KW_WORK, KW_WRITE, KW_NVL, KW_ESCAPE, KW_CONVERT, KW_VSIZE, KW_NULLIF
%token KW_BOTH, KW_LEAD, KW_TRAIL, KW_TRIM
%token KW_SELSTAR
%token KW_LOCK, KW_SHARE,KW_EXCLUSIVE,KW_INTENT,KW_MODE, KW_COALESCE
%token KW_EXTRACT, KW_INTERVAL, KW_OVERLAPS
%token KW_USING, KW_INNER, KW_NATURAL, KW_CONSTR_OP
%token KW_DATEADD, KW_DATEDIFF, KW_DATEPART, KW_AUDIT, KW_WHENEVER, KW_SUCCESSFUL, KW_NOAUDIT
%token KW_TIMESTAMPADD, KW_TIMESTAMPDIFF, KW_INSERTING, KW_DELETING, KW_UPDATING, KW_TRIGGERS
%token KW_CATALOG, KW_SUBSTRING, KW_IDENTITY, KW_IDENTITY_INSERT, KW_OFF
%token KW_TOP, KW_PERCENT, KW_TIES
%token KW_SEQUENCE, KW_START_WITH, KW_INCREMENT, KW_MAXVALUE, KW_NOMAXVALUE, KW_MINVALUE, KW_NOMINVALUE
%token KW_CYCLE, KW_NOCYCLE, KW_CACHE, KW_NOCACHE, KW_NOORDER
%token KW_STORAGE, KW_INITIAL, KW_MINEXTENTS, KW_CLUSTER, KW_HEXTORAW, KW_RAWTOHEX, KW_FILLFACTOR
%token KW_CONTAINS, KW_FILEGROUP
%token KW_RELATED, KW_LIMIT, KW_UNLIMITED, KW_EXTERNALLY
%token KW_SESSION_PER_USER, KW_CONNECT_IDLE_TIME, KW_FAILED_LOGIN_ATTEMPS, KW_PASSWORD_LIFE_TIME
%token KW_PASSWORD_REUSE_TIME, KW_PASSWORD_REUSE_MAX, KW_PASSWORD_LOCK_TIME, KW_PASSWORD_GRACE_TIME
%token KW_LABEL, KW_HIDE, KW_POLICY, KW_CATEGORY
%token KW_CASCADED, KW_EXCEPT, KW_LINK, KW_OFFSET, KW_VALUE, KW_ANALYZE, KW_SERERR
%token KW_SUSPEND, KW_LOGOUT, KW_RULE, KW_STARTUP, KW_SHUTDOWN, KW_TIMES
%token KW_ALLOW_IP, KW_NOT_ALLOW_IP, KW_ALLOW_DATETIME, KW_NOT_ALLOW_DATETIME
%token KW_PASSWORD_POLICY, KW_EVENTINFO, KW_DISKSPACE

%left		KW_OR
%left		KW_AND
%right		KW_NOT
%right		'='
%nonassoc	'<' '>'

/* for "||", to concat two strings */
%left       KW_CONSTR_OP

%left		'+' '-' '&' '|' '^'
%left		'*' '/' '%'

%left		KW_UNION
%left		KW_ALL

/* Unary Operators */
%right		UMINUS '~'
%left		'.'
%left		'[' ']'
%left		'(' ')'

//%start dmprogram

%%

/***********************************************
	dmprogram
	only support a simgle SQL statement
***********************************************/
dmprogram : 
	dmsqls
    	{  
    	}    	
	| create_schema_stmt
    	{
    	}
	| '{' KW_CALL full_proc_name exp_list_null endoption '}'
    	{		
		if (par_error == null || par_error.getErrorNodeNum() == 0)
			par_add_sql(false, null, null, null);
	}
	| '{' stm_param '=' call_proc_stmt '}'
	{
		if (par_error == null || par_error.getErrorNodeNum() == 0)
			par_add_sql(false, null, null, null);
	}
;
	
dmsqls : 
	dmsql endoption
	{
		if (par_error == null || par_error.getErrorNodeNum() == 0)
			par_add_sql(false, null, null, null);
	}	
	| KW_EXPLAIN dmsql endoption	
	{	
		if (par_error == null || par_error.getErrorNodeNum() == 0)
			par_add_sql(false, null, null, null);	
	}
	| dmsqls dmsql endoption	
	{
		if (par_error == null || par_error.getErrorNodeNum() == 0)
			par_add_sql(false, null, null, null);	
	}	
	| local_cmd endoption	
	{	
	}
	| dmsqls local_cmd endoption	
	{	
	};
	
local_cmd :
	autocmt_cmd
	| timeout_cmd
	| data_disp_mode_cmd
	| data_fetch_lines_cmd
;
	
autocmt_cmd :
	KW_SET id switch_option
	{
	}
;

timeout_cmd :
	KW_SET id lt_integer
	{
	}
;

data_disp_mode_cmd :
	KW_SET id id
	{
	}	
;

data_fetch_lines_cmd :
	KW_SET id KW_ALL
	{
	}
;

switch_option :
	KW_ON
	{
	}
	| KW_OFF
	{
	}
;

dmsubprogram : 
	decl_var_cur_list_null KW_BEGIN plbody endoption except_option KW_END
    	{
	}
;

decl_var_cur_list_null :
    	{
	}
	| KW_DECLARE decl_var_cur_list
    	{ 
    	}
	| decl_var_cur_list
    	{
    	}
;

decl_var_cur_list :
	decl_variable
    	{
    	}
	| decl_except
    	{
    	}
	| decl_cursor endoption
    	{
    	}
	| decl_variable decl_var_cur_list
    	{
    	}
	| decl_except decl_var_cur_list
    	{
    	}
	| decl_cursor endoption decl_var_cur_list
    	{
    	}
;

decl_variable :
 	variable_name_list datatype default_clause_option endoption
    	{
    	}
;

default_clause_option :
	{
	}
    	| KW_DEFAULT default_exp
    	{
    	}
    	| KW_ASSIGN default_exp
    	{
    	}
;
	
variable_name_list : 
	variable_name
    	{
    	}
	| variable_name ',' variable_name_list 
    	{
    	}
;

decl_except :
    	except_name KW_EXCEPTION endoption
    	{
    	}
    	| except_name KW_EXCEPTION KW_FOR '-' lt_integer endoption
    	{
    	}
;

plbody : 
	label_demiliter_l label_name label_demiliter_r plsql endoption
    	{
    	}
	| label_demiliter_l label_name label_demiliter_r plsql endoption plbody
    	{
    	} 
	| plsql endoption
    	{
    	}
	| plsql endoption plbody
    	{
    	}                 
;

label_demiliter_l :
	LP_OP
    	{
		if (!lexer.lex_token.opstr.equals("<<"))
		{
			yyerror("OPS");
		}
    	}
;

label_demiliter_r :
	LP_OP
    	{
		if (!lexer.lex_token.opstr.equals(">>"))
		{
			yyerror("OPS");
		}
    	}
;

plsql :
	dmlsql
    	{
    	}
	| if_stmt 
    	{
    	}
	| assign_stmt 
    	{
    	}
	| goto_stmt 
    	{
    	}
	| while_stmt 
    	{
    	}
	| loop_stmt 
    	{
    	}
	| repeat_stmt 
    	{
    	}
	| for_stmt 
    	{
    	}
	| return_stmt
	{
    	}
	| plblock 
    	{
    	}
	| raise_stmt
    	{
    	}
	| exit_stmt
    	{
    	}
	| print_stmt
    	{
    	}
	| execute_stmt
    	{
    	}
	| null_stmt
    	{
    	}
;

dmsql :    
	dmlsql
    	{
    	}
	| ddlsql
    	{
	    	sqlType = DmdbConnection.SQL_TYPE_DDL;
	}
	| privsql
    	{
	    	sqlType = DmdbConnection.SQL_TYPE_PRIV;
	}
	| othersql
    	{
    	}
	| decl_cursor_stmt
    	{
	    	sqlType = DmdbConnection.SQL_TYPE_CUR;
    	}
	| error
	{
	}    
;

dmlsql :
	call_proc_stmt
    	{
    		sqlType = DmdbConnection.SQL_TYPE_CALL;
    	}
/*	| close_cursor_stmt
    	{
    		sqlType = DmdbConnection.SQL_TYPE_CUR;
    	}*/
	| delete_stmt
    	{
    		sqlType = DmdbConnection.SQL_TYPE_DELETE;
    	}
/*	| fetch_stmt
    	{
    		sqlType = DmdbConnection.SQL_TYPE_CUR;
    	}*/
	| insert_stmt
    	{
    		sqlType = DmdbConnection.SQL_TYPE_INSERT;
    	}
/*	| open_stmt
    	{
    		sqlType = DmdbConnection.SQL_TYPE_CUR;
    	}*/
	| select_stmt
    	{
    		sqlType = DmdbConnection.SQL_TYPE_SELECT;
    	}
	| update_stmt
    	{
    		sqlType = DmdbConnection.SQL_TYPE_UPDATE;
    	} 
/*	| trunc_table_stmt
    	{
    		sqlType = DmdbConnection.SQL_TYPE_DDL;
    	}*/
	| create_table_stmt
	{
		sqlType = DmdbConnection.SQL_TYPE_DDL;
	}
/*	| drop_stmt
    	{
    		sqlType = DmdbConnection.SQL_TYPE_DDL;
    	}
	| commit_trans_stmt
    	{
    		sqlType = DmdbConnection.SQL_TYPE_OTHER;
    	}
	| rollback_stmt
    	{
    		sqlType = DmdbConnection.SQL_TYPE_OTHER;
    	}
	| savepoint_stmt
    	{
    		sqlType = DmdbConnection.SQL_TYPE_OTHER;
    	}*/
    	| create_index_stmt
    	{
    		sqlType = DmdbConnection.SQL_TYPE_DDL;
    	}
;

ddlsql :	
    	alter_proc_stmt
    	{
    	}
    	| create_contextindex_stmt 
	{
	}
	| drop_contextindex_stmt 
	{
	}
	| alter_contextindex_stmt 
	{
	}
	| alter_table_stmt
    	{
    	}
	| alter_trigger_stmt
    	{
    	}
	| alter_view_stmt
    	{
    	}
	| create_database_stmt
    	{
    	}
	| create_func_stmt
    	{
    	}
	| create_proc_stmt
    	{
    	}
	| create_trigger_stmt
    	{
    	}
	| create_view_stmt
    	{
    	}
	| alter_database_stmt
	{
	}
	| create_user_stmt
	{
	}
	| create_role_stmt
	{
	}
    	| create_sequence_stmt
    	{
    	}
	| create_login_stmt
	{
	}
	| alter_login_stmt
	{
	}
;

privsql :
	grant_stmt
    	{
    	}
	| revoke_stmt
    	{
    	}
;

othersql :
	connect_stmt
    	{
    		sqlType = DmdbConnection.SQL_TYPE_CONNECT;
    	}
	| disconnect_stmt
	{
    		sqlType = DmdbConnection.SQL_TYPE_OTHER;
    	}
	| set_trans_stmt
    	{
    		sqlType = DmdbConnection.SQL_TYPE_OTHER;
    	}
	| set_curdb_stmt
	{
    		sqlType = DmdbConnection.SQL_TYPE_OTHER;
    	}
	| lock_table_stmt
    	{
    		sqlType = DmdbConnection.SQL_TYPE_OTHER;
    	}
	| audit_stmt
	{
    		sqlType = DmdbConnection.SQL_TYPE_OTHER;
	}  
    	| set_schema_stmt
    	{
    		sqlType = DmdbConnection.SQL_TYPE_OTHER;
    	}
	| set_identins_stmt  
    	{
    		sqlType = DmdbConnection.SQL_TYPE_OTHER;
    	}
;

set_schema_stmt:
    	KW_SET KW_SCHEMA qualified_name
    	{
    	}
;

plblock :
	KW_DECLARE decl_var_cur_list KW_BEGIN plbody endoption except_option KW_END
    	{
    	}    
	| KW_BEGIN plbody endoption except_option KW_END
    	{
    	}
;

except_option :
    	{
	}
	| KW_EXCEPTION except_handler_list 
	{
    	}    
;

except_handler_list :
	except_handler except_handler_list
	{
    	}
	| except_handler
	{
    	}
;

except_handler :
	KW_WHEN except_name KW_THEN plbody endoption
	{
    	}
;

except_name : 
	id
    	{
    	}
;


/*********************************************
	if_stmt
*********************************************/
if_stmt :
	KW_IF bool_exp KW_THEN plbody endoption elseif_lst_option else_option KW_END KW_IF
    	{
    	}
;

elseif_lst_option :
	{
	}
	| elseif_clause elseif_lst_option
    	{
    	}
;

elseif_clause :
	KW_ELSEIF bool_exp KW_THEN plbody endoption
    	{
    	}
;

else_option:
	{
	}
	| KW_ELSE plbody endoption
    	{
    	}
;


/*********************************************
	assign_stmt
*********************************************/
assign_stmt :
	assign_obj assign_op exp
    	{
    	}
	| KW_SET assign_obj assign_op exp
    	{
    	}
;

assign_obj :
	variable_name
	{
	}
	| '?'
	{
	}
	| ':' trig_new_name '.' column_name
	{
	}
	| ':' KW_NEW '.' column_name
	{
	}
	| ':' KW_OLD '.' column_name
	{
	}
;

assign_op :
	KW_ASSIGN
    	| '='
    	{
    	}    
;


/*********************************************
	goto_stmt
*********************************************/
goto_stmt :
	KW_GOTO label_name
    	{
    	}
;

/*********************************************
	while_stmt
*********************************************/
while_stmt :
	KW_WHILE bool_exp KW_LOOP plbody endoption KW_END KW_LOOP
    	{
    	}
;

/*********************************************
	loop_stmt
*********************************************/
loop_stmt :
	KW_LOOP plbody endoption KW_END KW_LOOP
    	{
    	}
;

/*********************************************
	repeat_stmt
*********************************************/
repeat_stmt :
	KW_REPEAT plbody endoption KW_UNTIL bool_exp
    	{
    	}
;

/*********************************************
	for_stmt
*********************************************/
for_stmt : 
	KW_FOR id KW_IN reverse_option exp KW_BOUNDARY exp
	KW_LOOP plbody endoption KW_END KW_LOOP
    	{
    	}
;

reverse_option: 
    	{
	}
	| KW_REVERSE
    	{
	}
;

/*********************************************
	exit_stmt
*********************************************/
exit_stmt : 
	KW_EXIT
    	{
    	}
	| KW_EXIT KW_WHEN bool_exp
	{
	}
	| KW_EXIT label_name
    	{
    	}
	| KW_EXIT label_name KW_WHEN bool_exp
    	{
    	}
;

/*********************************************
	null_stmt
*********************************************/
null_stmt : 
	KW_NULL
    	{
    	}
;

/*********************************************
	print_stmt
*********************************************/
print_stmt : 
	KW_PRINT exp
    	{
    	}
;

/*********************************************
	execute_stmt
*********************************************/
execute_stmt : 
	KW_EXECUTE KW_IMMEDIATE exp fetch_into_null using_clause_null
    	{
    	}
;

using_clause_null :
	{
	}
	| KW_USING using_exp_list
	{
	}
;

using_exp_list : 
	exp
    	{
    	}
    	| exp ',' using_exp_list
    	{
    	}
;

/**************************************
	alter_proc_stmt 
********************************/
alter_proc_stmt :
	KW_ALTER KW_PROCEDURE full_proc_name KW_COMPILE debug_tag
    	{
    	}
;

/********************** 
	alter_table_stmt 
*************************/
alter_table_stmt :
	KW_ALTER KW_TABLE full_table_name alter_table_actions
    	{
    	}
;

alter_table_actions: 
	alter_table_action
        {
        }
        | alter_table_action ',' alter_table_actions
        {
        }
;

column_def_list : 
	column_def
    	{
    	}
    	| column_def ',' column_def_list
    	{
    	}
;

alter_table_action :
    	KW_ADD column_tag '(' column_def_list ')'
    	{
    	}
    	|KW_ALTER column_tag column_name KW_SET KW_DEFAULT default_exp
    	{
    	}
	|KW_ALTER column_tag column_name KW_DROP KW_DEFAULT
    	{
    	}
	|KW_ADD  KW_CONSTRAINT constraint_name_null table_constraint_clause
    	{
    	}
	|KW_ADD table_constraint_clause
    	{
    	}
	|KW_DROP constraint_name_def restrict_cascade
    	{
    	}
	|KW_ALTER column_tag column_name KW_RENAME KW_TO column_name
    	{
    	}
	|KW_RENAME KW_TO table_name
    	{
    	}
	|KW_MODIFY  column_def
	{
	}
	|KW_ADD   column_tag column_def
    	{
    	}
	|KW_DROP column_tag '(' drop_column_list ')'
	{
	}
	|KW_DROP column_tag column_name restrict_cascade
	{
	}
	|KW_ENABLE KW_ALL KW_TRIGGERS
	{
	}
	|KW_DISABLE KW_ALL KW_TRIGGERS
	{
	}
	|KW_MODIFY constraint_name_def KW_TO table_constraint_clause
	{
	}
;

column_def :
	column_name 
	datatype 
	identity_clause_null
	column_constraint_def_null
    	{
    	}
    	|column_name 
	 datatype 
     	 default_clause
	 identity_clause_null
	 column_constraint_def_null
    	{
    	}
    	|column_name 
	 datatype 
	 identity_clause_null
	 column_constraint_def_null
     	 default_clause
    	{
    	}
;

identity_clause_null :
    	{
	}
    	| identity_clause
    	{
    	}
;

identity_clause :
	KW_IDENTITY '(' exp ',' exp ')'
    	{
    	}
	| KW_IDENTITY
	{
	}
;

default_clause :
	KW_DEFAULT default_exp
    	{
    	}
;

default_exp :
	exp
    	{
    	}
;

column_constraint_def_null :
    	{
	}
	| column_constraint_def
    	{
    	}
;

column_constraint_def :	
	column_constraints constraint_attributes_null
    	{
    	}
;

constraint_name_def_null :
    	{
	}
	| constraint_name_def
    	{
    	}
;

constraint_name_def :
	KW_CONSTRAINT constraint_name
    	{
    	}
;

column_constraints :
	column_constraint
    	{
    	}
	| column_constraints column_constraint
    	{
    	}
;

column_constraint :
	constraint_name_def_null column_constraint_action
	{
	}
;

column_constraint_action :
	not_null_spec
    	{
    	}
	| unique_spec 
    	{        
    	}
	| refs_spec 
    	{
    	}
	| check_constraint_def 
    	{
    	}
;

not_null_spec :
	not_tag KW_NULL
    	{
    	}
;

unique_spec :
	KW_UNIQUE
    	{
    	}
	| KW_PRIMARY KW_KEY
    	{
    	}
	| KW_CLUSTER KW_PRIMARY KW_KEY
	{
	}
    	| KW_NOT KW_CLUSTER KW_PRIMARY KW_KEY
    	{
    	}
;

refs_spec : 
KW_REFERENCES pendant_tag refd_table_and_columns
	match_option ref_triggered_action
    	{
    	}
	| KW_REFERENCES pendant_tag refd_table_and_columns
	match_option ref_triggered_action KW_WITH KW_INDEX
	{
	}
/*  ˴﷨isql.yһ
    	| KW_REFERENCES pendant_tag refd_table_and_columns
	match_option ref_triggered_action KW_WITH KW_INDEX
    	{
    	}*/
;

refd_table_and_columns : 
	full_table_name
    	{
    	}
	| full_table_name '(' ref_column_list ')'
    	{
    	}
;

ref_column_list : 
	column_list
    	{
    	}
;

column_list : 
	column_name
    	{
    	}
	| column_name ',' column_list
    	{
    	}
;

drop_column_list : 
	column_name restrict_cascade
    	{
    	}
	| column_name restrict_cascade ',' drop_column_list
    	{
    	}
;

match_option :
    	{
	}
	| KW_MATCH match_type
    	{
    	}
;

match_type :
	KW_FULL
    	{
    	}
	| KW_PARTIAL
    	{
    	}
;

ref_triggered_action :
    	{
	}
	|update_rule
    	{
    	}
	| delete_rule
    	{
    	}
	| update_rule delete_rule
    	{
    	}
	| delete_rule update_rule
    	{
    	}
;

update_rule :
	KW_ON KW_UPDATE ref_action
    	{
    	}
;

delete_rule :
	KW_ON KW_DELETE ref_action
    	{
    	}
;

ref_action :
	KW_CASCADE
    	{
    	}
	| KW_SET KW_NULL
    	{
    	}
	| KW_SET KW_DEFAULT
    	{
    	}
	| id KW_ACTION
    	{
    	}
;	

check_constraint_def :
	KW_CHECK '(' check_condition ')'
    	{
    	}
;

check_condition : 
	bool_exp
    	{
    	}
;

restrict_cascade : 
    	{
	}
	| KW_RESTRICT 
    	{
    	}
	| KW_CASCADE
    	{
    	}
;

constraint_name_null : 
    	{
	}
	| constraint_name
    	{
    	}
;

constraint_attributes_null :
    	{
	}
	| constraint_attributes
    	{
    	}
;

constraint_attributes :
	constraint_check_time
    	{
    	}
	| deferrable_option
    	{
    	}
	| constraint_check_time deferrable_option
    	{
    	}
	| deferrable_option constraint_check_time
    	{
    	}
;

deferrable_option :
	KW_DEFERRABLE
    	{
    	}
;

constraint_check_time :
	KW_INITIALLY KW_DEFERRABLE
    	{
    	}
	| KW_INITIALLY KW_IMMEDIATE
    	{
    	}
;

table_constraint_clause :
	table_constraint constraint_attributes_null
    	{
    	}
;

table_constraint :
	unique_spec '(' column_list ')' 
    	{
    	}
	| foreign_key_clause 
    	{
    	}
	| check_constraint_def
    	{
    	}
;

foreign_key_clause : 
	KW_FOREIGN KW_KEY '(' ref_column_list ')' refs_spec
    	{
    	}
;

/****************************************
	alter_trigger_stmt
******************************************/
alter_trigger_stmt :
	KW_ALTER KW_TRIGGER full_trigger_name alter_trigger_option
    	{
    	}
;

alter_trigger_option :
	KW_ENABLE
    	{
    	}
	| KW_DISABLE
    	{
    	}
	| KW_COMPILE debug_tag
    	{
    	}
;

/*******************************************
	alter_view_stmt
******************************************/
alter_view_stmt : 
	KW_ALTER KW_VIEW full_view_name KW_COMPILE
    	{
    	}


/****************************************************************
	call_proc_stmt
	"CALL" can be obmitted. eg. a procedure names check_cost 
without parameters can be called by "CALL check_cost()", "CALL 
check_cost", "check_cost()" or "check_cost" 
*****************************************************************/
call_proc_stmt : 
	KW_CALL full_proc_name  exp_list_null
    	{
    	}
	| full_proc_name  exp_list_null 
    	{
    	}
	| KW_EXECUTE full_proc_name
	{
	}
	| KW_EXECUTE full_proc_name raw_exp_list
	{
	}
;

exp_list_null :
    	{
	}
	| '(' ')'
    	{
	}
	|  '(' exp_list ')'
    	{
    	}
;

raw_exp_list :
	raw_exp
	{
 	}
    	| raw_exp ',' raw_exp_list
    	{
    	}
;

exp_list : 
	exp
    	{
    	}
	| exp ',' exp_list
    	{
    	}
;

ins_exp_list : 
	exp
    	{
    	}
    	| exp ',' ins_exp_list
    	{
    	}
    	|KW_DEFAULT
    	{   
    	}
	|KW_DEFAULT ',' ins_exp_list
    	{
    	}
;


/**************************************
	close_cursor_stmt
***************************************/
/*close_cursor_stmt : 
	KW_CLOSE cursor_name
    	{
    	}
;*/

/*********************************************
	commit_trans_stmt
*********************************************/
/*commit_trans_stmt :
	commit_head commit_tail
    	{
    	}
;

commit_head : 
	KW_COMMIT 
    	{
    	}
	| KW_COMMIT KW_WORK 
    	{
    	}
	| KW_COMMITWORK
    	{
    	}
;

commit_tail :
    	{
	}
	| KW_AND KW_CHAIN
    	{
    	}
	| KW_AND id KW_CHAIN
    	{
    	}
;
*/

/*********************************************
	connect_stmt
*********************************************/
connect_stmt :
	KW_CONNECT KW_LOGIN user_name KW_IDENTIFIED KW_BY password KW_DATABASE database_name
    	{
    	}
;

password : 
	id
	{
	}
;
	

/************************************************************
	create_database_stmt
************************************************************/
create_database_stmt :
	KW_CREATE db_type_option KW_DATABASE database_name KW_DATAFILE pathname id lt_integer
    	{
	}
;

db_type_option :
	{}
	| KW_TEMPORARY
	{}
	| KW_ROLLBACK
	{}

pathname : 
	LT_STRING
	{
	}
;

/************************************************************
	create_func_stmt
	function is called by its name followed with "()", even
if it hasn't any parameter. 
	Like procedure, SQL statements in function must be DMLs, 
and select_stmt must has into_clause.
************************************************************/
create_func_stmt :
	KW_CREATE replace_option KW_FUNCTION 
	full_func_name 
	at_database_null
	param_def_list_option
	KW_RETURN datatype 
	func_action	
    	{
    	}
    	| KW_CREATE replace_option KW_FUNCTION 
	full_func_name 
	at_database_null
	param_def_list_option
	KW_RETURN datatype 
    	KW_WITH KW_ENCRYPTION
	func_action
    	{
    	}
;

replace_option :
	{
	}
	| KW_OR KW_REPLACE
	{
	}
;

func_action :
	is_as dmsubprogram
	{
	}
	| KW_EXTERNAL pathname inner_fun_name_null
	{
	}
;

inner_fun_name_null :
    	{
	}
	| LT_STRING
    	{
    	}
;

param_def_list_option :
    	{
	}
	| '(' param_def_list ')'
    	{
    	}
;

param_def_list :
	param_def
    	{
    	}
	|  param_def ',' param_def_list
    	{
    	}
;

param_def :
	param_name param_in_out_option datatype default_clause_option
    	{
    	}
;

param_in_out_option :
	{
	}
	| KW_IN
    	{
    	}
	| KW_OUT
    	{
    	}
	| KW_IN KW_OUT
    	{
    	}
	| KW_OUT KW_IN
    	{
    	}
;

is_as :
	KW_IS
    	{
    	}
	| KW_AS
    	{
    	}
;

/*********************************************
	create_index_stmt
	do not support expression on index
*********************************************/
create_index_stmt :
	KW_CREATE replace_option unique_tag KW_INDEX
	index_name KW_ON full_table_name '(' index_column_list ')' storage_tag
 	{
    	}
;

index_column_list :
	index_column_name
	{
	}
	| index_column_name ',' index_column_list
	{
	}
;

index_column_name :
	column_name asc_desc_option
	{
	}
;

storage_tag :
	{ 
	}
	| KW_STORAGE '(' storage_list ')'
    	{
    	}
;

storage_list :
	storage
	{
	}
	| storage ',' storage_list
	{
	}
;

storage :
	KW_INITIAL lt_integer
    	{
    	}
	| KW_NEXT lt_integer
    	{
    	}
	| KW_MINEXTENTS lt_integer
    	{
    	}
	| KW_ON id
    	{
    	}
	| KW_FILLFACTOR lt_integer
	{
	}
;

/*********************************************
	create_proc_stmt
	Like function, SQL statements in procedure must be DMLs, 
and select_stmt must has into_clause.
*********************************************/
create_proc_stmt :
	KW_CREATE replace_option KW_PROCEDURE
	full_proc_name 
	at_database_null 
	param_def_list_option
	is_as dmsubprogram
    	{
    	}
    	| KW_CREATE replace_option KW_PROCEDURE
	full_proc_name
	at_database_null 
	param_def_list_option
    	KW_WITH KW_ENCRYPTION
	is_as dmsubprogram
    	{
    	} 
;


/*********************************************
	create_table_stmt
*********************************************/
create_table_stmt :
	KW_CREATE table_temp_option 
	KW_TABLE full_table_name 
	at_database_null
	'(' table_element_list ')' 
	on_commit_option
	storage_tag
	{
    	}
	| KW_CREATE table_temp_option KW_TABLE full_table_name KW_AS without_into_select
	{
	}
;

table_temp_option :
    	{
	}
	| KW_GLOBAL KW_TEMPORARY
    	{
    	}
	| KW_LOCAL KW_TEMPORARY
    	{
    	}
;

at_database_null :
    	{
	}
	| id database_name
    	{
    	}
;

table_element_list :
	table_element
    	{
    	}
	| table_element ',' table_element_list 
    	{
    	}
;

table_element :
	column_def 
    	{
    	}
	| table_constraint_def
    	{
    	}
;

table_constraint_def :
	constraint_name_def_null table_constraint_clause
    	{
    	}
;

on_commit_option :
    	{
	}
	| KW_ON KW_COMMIT del_res KW_ROWS
    	{
    	}
;

del_res : 
	KW_DELETE 
    	{
    	}
	| KW_PRESERVE
    	{
    	}
;
	

/***********************************************************
	create_trigger_stmt
	Like function and procedure, SQL statements in trigger 
must be DMLs, and select_stmt must has into_clause.
************************************************************/
create_trigger_stmt :
	KW_CREATE replace_option KW_TRIGGER trigger_name
	before_after trig_del_ins_upd_list
	KW_ON full_table_name
	trig_referencing_def_null
	trig_for_each_option
	trig_when_option
	dmsubprogram
    	{
    	}
    	| KW_CREATE replace_option KW_TRIGGER trigger_name
	before_after trig_del_ins_upd_list
	KW_ON full_table_name
    	KW_WITH KW_ENCRYPTION
	trig_referencing_def_null
	trig_for_each_option
	trig_when_option
	dmsubprogram
	{
	}
;

before_after :
	KW_BEFORE
    	{
    	}
	| KW_AFTER
    	{
    	}
;

trig_del_ins_upd_list :
	trig_del_ins_upd
    	{
    	}
	| trig_del_ins_upd_list KW_OR trig_del_ins_upd
    	{
    	}
;

trig_del_ins_upd : 
	KW_DELETE
    	{
    	}
	| KW_INSERT
    	{
    	}
	| update_of_option
    	{
    	}
;

update_of_option :
	KW_UPDATE
    	{
	}
	| KW_UPDATE KW_OF column_list 
    	{
    	}
;

trig_referencing_def_null :
    	{
	}
	| trig_referencing_def
    	{
    	}
;

trig_referencing_def :
	KW_REFERENCING trig_referencing_list
    	{
    	}
;

trig_referencing_list :
	trig_referencing
    	{
    	}
	| trig_referencing_list trig_referencing
    	{
    	}
;

trig_referencing :
	KW_OLD row_tag as_tag trig_old_name
    	{
    	}
	| KW_NEW row_tag as_tag trig_new_name
    	{
	}
;

trig_for_each_option :
    	{
	}
	| KW_FOR KW_EACH KW_ROW
    	{
    	}
	| KW_FOR KW_EACH KW_STATEMENT
    	{
    	}
;
	
trig_when_option :
    	{
	}
	| KW_WHEN '(' trig_when_condition ')'
    	{
    	}
;

trig_when_condition : 
	bool_exp
	{
	}
;


/*********************************************
	create_view_stmt
*********************************************/
create_view_stmt :
	KW_CREATE replace_option KW_VIEW full_view_name column_list_null
	KW_AS subquery order_by_null with_check_option 
    	{
    	}
    	|KW_CREATE replace_option KW_VIEW full_view_name
    	column_list_null KW_AS joined_table
    	{
    	}
;

column_list_null :
    	{
	}
	| '(' column_list ')'
    	{
    	}
;

with_check_option: 
     	{
	}
	| KW_WITH KW_CHECK KW_OPTION
    	{
    	}
;


/*********************************************
	decl_cursor_stmt
*********************************************/
decl_cursor_stmt : 
	KW_DECLARE decl_cursor
    	{
    	}
;

decl_cursor :
	cursor_name KW_CURSOR KW_FOR without_into_select
    	{
    	}
    	|cursor_name KW_CURSOR KW_FOR joined_table
    	{
	}
	|cursor_name KW_CURSOR
	{
	}
;


/*********************************************
	delete_stmt
*********************************************/
delete_stmt : 
	KW_DELETE from_tag from_tv where_current_option
    	{
    	}
;

where_current_option :
	where_clause_null
    	{
    	}
	| KW_WHERE KW_CURRENT KW_OF cursor_name
    	{
    	}
	| KW_WHERE KW_CURRENT KW_OF KW_CURSOR
	{
	}
;

where_clause_null :
    	{
    	}
	| KW_WHERE search_condition
    	{
    	}
;

search_condition : 
	bool_exp
	{
	}
;


/*********************************************
	disconnect_stmt
*********************************************/
disconnect_stmt :
	KW_DISCONNECT disconnect_option
    	{
    	}
;

disconnect_option :
	KW_CURRENT
    	{
    	}
	| KW_ALL
    	{
    	}
;

/*********************************************
	drop_stmt
*********************************************/
/*drop_stmt :
	KW_DROP db_object full_object_name restrict_cascade
    	{
    	}
;
*/
db_object_null :
	{
	}
	| db_object
	{
	}
;

db_object :
	KW_DATABASE
    	{
    	}
	| KW_FUNCTION
    	{
    	}
	| KW_INDEX
    	{
        }
	| KW_PROCEDURE
    	{
    	}
	| KW_TABLE
    	{
    	}
	| KW_TRIGGER
    	{
    	}
	| KW_VIEW
    	{
    	}
	| KW_USER
    	{
    	}
	| KW_ROLE
    	{
    	}
	| KW_SCHEMA
	{
	}
    	| KW_SEQUENCE
    	{
    	}
	| KW_LOGIN
	{
	}
;


/*********************************************
	alter_database_stmt
*********************************************/

alter_database_stmt :
	KW_ALTER KW_DATABASE database_name alter_database_action
	{
	}
;

filegroupoption :
	{
	}
	| KW_ON KW_FILEGROUP id
	{
	}
;

alter_database_action :
	KW_ADD KW_DATAFILE pathname id lt_integer filegroupoption
	{
	}
	| KW_MODIFY KW_DATAFILE  pathname KW_INCREASE lt_integer filegroupoption
	{
	}
	| KW_SET id
	{
	}
	| KW_ADD KW_FILEGROUP id KW_DEFAULT KW_DATAFILE pathname id lt_integer
	{
	}
;

/*********************************************
	fetch_stmt
*********************************************/
/*fetch_stmt :
	KW_FETCH fetch_option cursor_name fetch_into_null
    	{
    	}
;

fetch_option :
    	{
	}
	| fetch_direct_option from_tag
    	{
    	}
;

fetch_direct_option :
	KW_NEXT
    	{
    	}
	| KW_PRIOR
    	{
    	}
	| KW_FIRST
    	{
    	}
	| KW_LAST
    	{
    	}
	| KW_ABSOLUTE lt_integer
    	{
    	}
	| KW_RELATIVE lt_integer
    	{
    	}
;
*/
fetch_into_null :
    	{
	}
	| KW_INTO assign_obj_list
    	{
    	}
;


/****************************************************
	insert_stmt
	multimedia value cannot be inserted directly with
insert_stmt.
*****************************************************/
insert_stmt :
	KW_INSERT into_tag full_tv_name 
	column_list_null insert_action
    	{
    	}
;

insert_action :
	KW_VALUES '(' ins_value_list ')'
    	{
    	}
	| subquery order_by_null
    	{
    	}
    	| KW_DEFAULT KW_VALUES
    	{
    	}
	| call_proc_stmt
	{
	}
;


/*********************************************
	open_stmt
*********************************************/
/*open_stmt :
	KW_OPEN cursor_name
    	{
    	}
	|KW_OPEN cursor_name KW_FOR without_into_select
	{
	}
	|KW_OPEN cursor_name KW_FOR exp using_clause_null
	{
	}
;*/


/*********************************************
	return_stmt
*********************************************/
return_stmt :
	KW_RETURN
    	{
    	}
	| KW_RETURN exp
    	{
    	}
;


/*********************************************
	raise_stmt
*********************************************/
raise_stmt :
	KW_RAISE except_name
	{
    	}
;

/*********************************************
	rollback_stmt
*********************************************/
/*rollback_stmt :
	KW_ROLLBACK work_tag to_savepoint_null
    	{
    	}
;

to_savepoint_null :
	{
	}
	| KW_TO KW_SAVEPOINT savepoint_name
    	{
    	}
;*/

/*********************************************
	savepoint_stmt
*********************************************/
/*savepoint_stmt :
	KW_SAVEPOINT savepoint_name
    	{
    	}
;*/

	
/************************************************************************
	select_stmt
	select_stmt is divided into two types as following. 
	"with_into_select" is like "select ... into ... from ... where_clause
group_having_clause". because we don't support array at this time, 
"with_into_select" can only get one available tuple. 
	"without_into_select" hasn't into_clause, while it supports order_by
and for_update option.
	we don't support set search_condition on multimedia column.

*************************************************************************/
select_stmt :
	with_into_select
    	{
    	}
	| without_into_select
    	{
    	}
;   

with_into_select :
	KW_SELECT all_distinct_option top_option select_item_list_ex
	KW_INTO assign_obj_list	select_tail order_by_null
    	{
    	}
;

assign_obj_list :
	assign_obj
	{
	}
	| assign_obj ',' assign_obj_list
	{
	}
;

all_distinct_option :
    	{
	}
	| KW_ALL
    	{
    	}
	| KW_DISTINCT
    	{
    	}
;

top_option :
	{
    	}    
    	|KW_TOP lt_integer
    	{
    	}
    	| KW_TOP lt_integer KW_PERCENT
    	{
    	}    
    	| KW_TOP lt_integer KW_WITH KW_TIES
    	{
    	}
    	| KW_TOP lt_integer KW_PERCENT KW_WITH KW_TIES
    	{
    	}
    	| KW_TOP lt_integer ',' lt_integer
    	{
    	}
;

select_item_list_ex:
    	select_item_list
	{
	}
;

select_item_list:
	select_item
    	{
    	}
	| select_item ',' select_item_list 
    	{
    	}
;

select_item :
	qualified_name KW_SELSTAR
    	{
    	}
	| exp alias
    	{
    	}
	| exp 
    	{
    	}
	| exp KW_AS alias
	{
    	}
	| '*'
    	{
    	}
    
;

as_alias_null :
    	{
	}
	| KW_AS alias
    	{
    	}
;


select_tail : 
	from_clause_null
	where_clause_null
	group_null
	having_null
    	{
    	}
;

from_clause_null :
	{
	}
	| from_clause
    	{
    	}
;

from_clause :
    	KW_FROM from_tv_list
    	{
    	}
;

from_tv_list :
	from_tv
    	{
    	}
	| from_tv ',' from_tv_list 
    	{
    	}
;

from_tv :
	normal_tv
	{
	}
	|joined_table
	{
	}
;

normal_tv :
	full_tv_name as_alias_null
    	{
    	}
	|full_tv_name alias
	{
	}
    	| '(' without_into_select ')' id column_list_null
    	{
    	}
    	| '(' without_into_select ')' KW_AS id column_list_null
    	{
    	}
	| '(' without_into_select ')'
	{
	}
;

joined_table :
	cross_join
	{
	}
	| '{' id qualified_join '}'
	{
	}
    	| qualified_join  
	{
	}
	|'(' joined_table ')'
	{
	}
;

cross_join :
	from_tv KW_CROSS KW_JOIN normal_tv
	{
	}
    	| from_tv KW_CROSS KW_JOIN '(' joined_table ')'
    	{
	}
;

qualified_join:
	from_tv KW_NATURAL KW_JOIN normal_tv
	{
	}
    	| from_tv KW_NATURAL KW_JOIN '(' joined_table ')'
    	{
	}
	| from_tv KW_NATURAL join_type KW_JOIN normal_tv
	{
	}
    	| from_tv KW_NATURAL join_type KW_JOIN '(' joined_table ')'
    	{
	}
    	| from_tv KW_JOIN from_tv qualified_joinspec
	{
	}
	| from_tv join_type KW_JOIN from_tv qualified_joinspec
	{
	}	
;

qualified_joinspec:
	KW_ON join_condition
	{
	}
	| named_columns_join
	{
	}
;

named_columns_join:
	KW_USING '(' column_list ')'
	{
	}
;

join_type :
	KW_INNER
	{
	}
	|outer_join_type 
	{
	}
	|outer_join_type KW_OUTER
	{
	}	
;

outer_join_type :
	KW_LEFT
	{
	}
	|KW_RIGHT
	{
	}
	|KW_FULL
	{
	}
;

join_condition :
	bool_exp
    	{
    	}
;

group_null :
	{
	}
	| KW_GROUP KW_BY exp_list
	{
	}
;

having_null :
    	{
	}
	| KW_HAVING search_condition
	{
    	}
;

without_into_select :
	subquery order_by_null for_update_null
    	{
    	}
;

subquery : 
	query_exp
    	{
    	}
	| subquery KW_UNION subquery
    	{
    	}
	| subquery KW_UNION KW_ALL subquery
    	{
    	}
	| '(' subquery ')'
	{
	}
;

query_exp :
	KW_SELECT all_distinct_option top_option select_item_list_ex select_tail
    	{
	}
	| KW_SELECT KW_ABSOLUTE '*' KW_FROM full_tv_name
    	{
    	}
;

order_by_null :
    	{
	}
	| KW_ORDER KW_BY order_by_list
	{
	}
;

asc_desc_option :
	{
	}
	| KW_ASC
	{
	}
	| KW_DESC
	{
	}
;

order_by_list :
	order_by_item
	{
	}
	| order_by_item ',' order_by_list 
	{
	}
;

order_by_item :
    	exp asc_desc_option
    	{
	}
;

for_update_null :
    	{
	}
	| KW_FOR KW_READ KW_ONLY
	{
	}
	| KW_FOR update_of_option
    	{
    	}
;


/*********************************************
	set_trans_stmt
*********************************************/
set_trans_stmt : 
	KW_SET KW_TRANSACTION trans_rw_option
	{
	}
	| KW_SET KW_TRANSACTION KW_ISOLATION KW_LEVEL trans_level_option
	{
	}
;

trans_rw_option :
	KW_READ KW_ONLY
	{
	}
	| KW_READ KW_WRITE
	{
	}
;

set_curdb_stmt :
	KW_SET KW_CURRENT KW_DATABASE id
	{
	}
    	|KW_SET KW_CATALOG id
    	{      
    	}
    	|KW_SET KW_CURRENT KW_CATALOG id
	{
	}
;


trans_level_option : 
	KW_READ KW_UNCOMMITED
    	{
    	}
	| KW_READ KW_COMMITED
    	{
    	}
	| KW_REPEATABLE KW_READ
    	{
    	}
	| KW_SERIALIZABLE
    	{
    	}
;

/*********************************************
	lock_table_stmt
*********************************************/
lock_table_stmt : 
	KW_LOCK KW_TABLE full_table_name KW_IN lock_mode_option KW_MODE
    	{
    	}
	| KW_LOCK KW_TABLE full_table_name KW_IN lock_mode_option KW_MODE KW_NOWAIT
    	{
    	}
;

lock_mode_option :
	KW_SHARE
    	{
    	}
	| KW_EXCLUSIVE
    	{
    	}
	| KW_INTENT KW_SHARE
    	{
    	}
	| KW_INTENT KW_EXCLUSIVE
    	{
    	}
;

/*********************************************
	set_identins_stmt
*********************************************/
set_identins_stmt : 
	KW_SET KW_IDENTITY_INSERT full_table_name set_identins_option
    	{
    	}
;
set_identins_option :
	KW_OFF
    	{
    	}
	| KW_ON
    	{
    	}
;


/*********************************************
	trunc_table_stmt
*********************************************/
/*trunc_table_stmt :
     	KW_TRUNCATE KW_TABLE full_table_name
     	{
    	}
;*/


/*********************************************
	update_stmt
*********************************************/
update_stmt :
	KW_UPDATE full_tv_name 
	KW_SET set_value_list
    	from_clause_null
	where_current_option
    	{
    	}
;

set_value_list : 
	set_value_node
    	{
    	}
	| set_value_node ',' set_value_list 
    	{
    	}
;

set_value_node : 
	full_column_name '=' KW_DEFAULT
    	{
    	}
	|full_column_name '=' exp
    	{
    	}
;

/*********************************************
	create_login_stmt
*********************************************/
create_login_stmt :
	KW_CREATE KW_LOGIN
	login_name KW_IDENTIFIED KW_BY password
	{
	}
;

/*********************************************
	alter_login_stmt
*********************************************/
alter_login_stmt :
	KW_ALTER KW_LOGIN
	login_name alter_login_action
	{
	}
;

alter_login_action :
	 KW_IDENTIFIED KW_BY password
	{
	}
	| KW_DEFAULT KW_DATABASE database_name
	{
	}
	| KW_ADD KW_USER user_name id database_name
	{
	}
	| KW_DROP KW_USER user_name id database_name
	{
	}
;

/*********************************************
	create_user_stmt
*********************************************/
create_user_stmt :
	KW_CREATE KW_USER user_name at_database_null
	{
	}
;

/*********************************************
	create_role_stmt
*********************************************/
create_role_stmt :
	KW_CREATE KW_ROLE role_name at_database_null
	{
	}
;

/********************************************
	create_sequence_stmt
********************************************/
create_sequence_stmt :
    	KW_CREATE KW_SEQUENCE sequence_name at_database_null
    	increment_option start_option maxvalue_option
    	minvalue_option cycle_option cache_option order_option
    	{
    	}
;

sequence_name : 
	qualified_name
    	{
    	}
;

increment_option :
    	{
    	}
    	| KW_INCREMENT KW_BY exp2
    	{
    	}
;

start_option :
    	{
    	}
    	| KW_START_WITH exp2
    	{
    	}
;

maxvalue_option  :
    	{
    	}
    	| KW_MAXVALUE exp2
    	{
    	}
    	| KW_NOMAXVALUE
    	{
    	}
;

minvalue_option :
    	{
    	}
    	| KW_MINVALUE exp2
    	{
    	}
    	| KW_NOMINVALUE
    	{
    	}
;

cycle_option :
    	{
    	}
    	| KW_CYCLE
    	{
    	}
    	| KW_NOCYCLE
    	{
    	}
;

cache_option :
    	{
    	}
    	| KW_CACHE
    	{
    	}
    	| KW_NOCACHE
    	{
    	}
;

order_option :
    	{
    	}
    	| KW_ORDER
    	{
    	}
    	| KW_NOORDER
    	{
    	}
;

/********************************************
	audit_stmt
*********************************************/
audit_stmt :
    	KW_AUDIT audit_action
	{
	}
	|
	KW_NOAUDIT audit_action
	{
	}
;

on_tv_null :
	{
	}
	|
	KW_ON full_tv_name
	{
	}
;

user_list :
     	user_name
	{
	}
	| user_name ',' user_list
	{	
	}
;

by_user_null :
	{
	}
	|
	KW_BY user_list at_database_null
	{		
	}
;

whenever_stmt_null :
	{
	}
	|
	KW_WHENEVER whenever_stmt
	{		
	}
;

audit_action:
	stmt_list on_tv_null by_user_null  whenever_stmt_null
	{		
	}
;

stmt_list:
     	stmt_option
	{    
	}
	| stmt_option ',' stmt_list
	{		
	}
;

whenever_stmt:
    	KW_SUCCESSFUL
	{		
	}
	| KW_NOT KW_SUCCESSFUL
	{		
	}
;

stmt_option :
	KW_ALL 
    	{
    	}
	| KW_CONNECT
	{
    	}
	| KW_ALTER KW_TABLE
	{
    	}
	| KW_ALTER KW_TRIGGER
	{
    	}
	| KW_AUDIT
	{
    	}
	| KW_CALL
	{
    	}
	| KW_COMMIT
	{
    	}
	| KW_CREATE KW_DATABASE
	{
    	}
	| KW_CREATE KW_FUNCTION
	{
    	}
	| KW_CREATE KW_INDEX
	{
    	}
	| KW_CREATE KW_PROCEDURE
	{
    	}
	| KW_CREATE KW_ROLE
	{
    	}
	| KW_CREATE KW_SCHEMA 
	{
    	}
	| KW_CREATE KW_TABLE
	{
    	}
	| KW_CREATE KW_TRIGGER
	{
    	}
	| KW_CREATE KW_USER
	{
    	}
	| KW_CREATE KW_VIEW
	{
    	}
	| KW_DROP KW_FUNCTION
	{
    	}
	| KW_DROP KW_INDEX
	{
    	}
	| KW_DROP KW_PROCEDURE
	{
    	}
	| KW_DROP KW_ROLE
	{
    	}
	| KW_DROP KW_SCHEMA
	{
    	}
	| KW_DROP KW_TABLE
	{
    	}
	| KW_DROP KW_TRIGGER
	{
    	}
	| KW_DROP KW_USER
	{
    	}
	| KW_DROP KW_VIEW
	{
    	}
	| KW_LOCK KW_TABLE
	{
    	}
	| KW_NOAUDIT
	{
    	}
	| KW_REVOKE
	{
    	}
	| KW_ROLLBACK
	{
	}
	| KW_INSERT
	{        
    	}
	| KW_SELECT
	{
    	}
	| KW_DELETE
	{
    	}
	| KW_UPDATE
	{
    	}
    	| KW_DROP KW_SEQUENCE
	{
    	}
	| KW_GRANT
	{
    	}
	| KW_CREATE KW_SEQUENCE
	{
    	}
	| KW_DROP KW_DATABASE
	{
    	}
	| KW_CREATE KW_CONTEXT KW_INDEX
	{
    	}
	| KW_DROP KW_CONTEXT KW_INDEX
	{
    	}
	| KW_ALTER KW_CONTEXT KW_INDEX
	{
    	}
	| KW_ALTER KW_VIEW
	{
    	}
	| KW_ALTER KW_DATABASE
	{
    	}
	| KW_CREATE KW_LOGIN
	{
    	}
	| KW_ALTER KW_LOGIN
	{
    	}
	| KW_DROP KW_LOGIN
	{
    	}
;


/*********************************************
	grant_stmt
*********************************************/
grant_stmt : 
	KW_GRANT object_privileges KW_TO grantees with_grant_option
    	{
    	}
	| KW_GRANT db_privileges KW_TO grantees with_grant_option
	{
	}
	| KW_GRANT role_name_list KW_TO grantees with_grant_option
    	{
    	}
;

object_privileges :
	grant_privs KW_ON db_object_null grant_object_name
    	{
    	}
;
db_privileges :
	grant_db_privs
	{
    	}
;

grant_privs :
	KW_ALL privileges_tag
    	{
    	}
	| grant_priv_list
    	{
    	}
;

grant_db_privs	:
	KW_ALL privileges_tag
    	{
    	}
	| grant_db_priv_list
    	{
    	}
;

grant_priv_list :
	grant_priv
	{
	}
	| grant_priv_list ',' grant_priv
	{
	}
;

grant_priv :
	KW_SELECT
    	{
    	}
	| KW_INSERT
    	{
    	}
	| KW_DELETE
    	{
    	}
	| KW_UPDATE
    	{
	}
	| KW_REFERENCES
    	{
    	}
	| KW_EXECUTE
    	{
    	}
	| KW_UPDATE '(' column_list ')'
	{
	}
	| KW_INSERT '(' column_list ')'
	{
	}
	| KW_REFERENCES '(' column_list ')'
	{
	}
;

grant_db_priv_list :
	grant_db_priv
	{
	}
	| grant_db_priv_list ',' grant_db_priv
	{
	}
;

grant_db_priv :
	KW_CREATE KW_USER
    	{
    	}
	| KW_CREATE KW_ROLE
    	{
    	}
	| KW_CREATE KW_TABLE
    	{
    	}
	| KW_CREATE KW_VIEW
    	{
    	}
	| KW_CREATE KW_PROCEDURE
    	{
    	}
	| KW_CREATE KW_FUNCTION
    	{
    	}
	| KW_CREATE KW_SCHEMA
    	{
    	}
	| KW_CREATE KW_SEQUENCE
    	{
    	}
	| KW_BACKUP
	{
	}
	| KW_RESTORE
	{
	}
;

grantees :
	user_role_name
    	{
    	}
	| grantees ',' user_role_name
	{
	}
;


/*********************************************
	revoke_stmt
*********************************************/
revoke_stmt :
	KW_REVOKE grant_option_for_tag object_privileges KW_FROM grantees restrict_cascade
    	{
    	}
	| KW_REVOKE grant_option_for_tag db_privileges KW_FROM grantees restrict_cascade
    	{
    	}
	| KW_REVOKE grant_option_for_tag role_name_list KW_FROM grantees restrict_cascade
    	{
    	}
;

/*********************************************
	create_schema_stmt
*********************************************/
create_schema_stmt :
create_schema_stmt :
	KW_CREATE KW_SCHEMA schema_name_null at_database_null authorization_null endoption
	{
	}
	grant_and_ddl_list_null
    	{
    	}
;

schema_name_null :
	{
	}
	| schema_name
	{
	}
;

authorization_null :
    	{
    	}
	| KW_AUTHORIZATION user_name
    	{
    	}
;

grant_and_ddl_list_null :
	{
	}
	| grant_and_ddl_list
	{
	}
;

grant_and_ddl_list :
	grant_and_ddl endoption
    	{
    	}
	| grant_and_ddl endoption grant_and_ddl_list
    	{
    	}
;

grant_and_ddl :
	grant_stmt endoption
    	{
    	}
	| create_func_stmt endoption
    	{
    	}
	| create_index_stmt endoption
    	{
    	}
	| create_proc_stmt endoption
    	{
    	}
	| create_table_stmt endoption
    	{
    	}
	| create_trigger_stmt endoption
    	{
    	}
	| create_view_stmt endoption
    	{
    	}
	| alter_table_stmt endoption
    	{
    	}
    	| create_sequence_stmt endoption
    	{
    	} 
;

	
/****************************************
	expressions 
****************************************/
raw_exp :
     	'-' raw_exp     %prec UMINUS
     	{
	}
     	| lt_integer
     	{ 
     	}
	| lt_binteger
     	{ 
     	}
     	| lt_decimal
     	{ 
     	}
     	| lt_real
     	{ 
     	}
     	| lt_string
     	{ 
     	}
     	| lt_bitstring
     	{ 
     	}
	| truth_value
	{
	}
     	| qualified_name
     	{
     	}
     	| null_value
     	{
     	}
     	| stm_param
     	{
     	}
	| id lt_string
	{
	}
	| KW_INTERVAL '+' lt_string interval_qualifier
	{
	}
	| KW_INTERVAL '-' lt_string interval_qualifier
	{
	}
	| KW_INTERVAL lt_string interval_qualifier
	{
	}
	| global_var
	{
	}
;

exp :
     	exp '+' exp
     	{
     	}
     	| exp '-' exp
     	{
     	}
     	| exp '*' exp
     	{
     	}
     	| exp '/' exp
     	{
     	}
 	| exp '&' exp
	{
	}
	| exp '|' exp
	{
	}
	| exp '^' exp
	{
	}
	| '(' exp '-' exp ')' interval_qualifier_null
	{
	}
     	| '(' exp ')'
     	{
     	}
     	| '+' exp %prec UMINUS
     	{
     	}
     	| '-' exp %prec UMINUS
     	{
	}
 	| '~' exp  
	{
	}
     	| lt_integer
     	{ 
     	}
	| lt_binteger
     	{ 
     	}
     	| lt_decimal
     	{ 
     	}
     	| lt_real
     	{ 
     	}
     	| lt_string
     	{ 
     	}
     	| lt_bitstring
     	{ 
     	}
	| truth_value
	{
	}
     	| qualified_name
     	{
     	}
     	| simple_case
     	{
     	}
     	| boolean_case
     	{
     	}
     	| KW_CAST '(' exp KW_AS datatype ')'
     	{
     	}
	| KW_HEXTORAW '(' exp ')'
	{
	}
	| KW_RAWTOHEX '(' exp ')'
	{
	}
     	| KW_CONVERT '(' datatype ',' exp')'
     	{
     	}
     	| funs
     	{
     	}
     	| set_funs
     	{
     	}
     	| null_value
     	{
     	}
     	| stm_param
     	{
     	}
     	| '(' query_exp ')'
     	{	
     	}
     	| KW_USER
     	{
     	}
     	| KW_USER '('  ')'
     	{
     	}
	| KW_NVL '(' exp ',' exp ')'
     	{
     	}
	| KW_COALESCE  '(' coalesce_value_list ')'
	{
	}
	| ':' trig_new_name '.' column_name
	{
	}
	| ':' KW_NEW '.' column_name
	{
	}
 	| ':' KW_OLD '.' column_name
	{
	}
	| id lt_string
	{
	}
	| KW_INTERVAL '+' lt_string interval_qualifier
	{
	}
	| KW_INTERVAL '-' lt_string interval_qualifier
	{
	}
	| KW_INTERVAL lt_string interval_qualifier
	{
	}
	| KW_TRIM '(' exp ')'
	{
	}
	| KW_TRIM  '(' orient_option KW_FROM exp ')'
	{
	}
	| KW_TRIM  '(' exp KW_FROM exp ')'
	{
	}
	| KW_TRIM  '(' orient_option exp KW_FROM exp ')'
	{
	}
	| KW_TRUNCATE '(' value_list ')'
	{
	}
	| KW_INSERT '(' value_list ')'
	{
	}
	| KW_REPLACE '(' value_list ')'
	{
	}
 	| KW_LEFT '(' value_list ')'
	{
	}
	| KW_RIGHT '(' value_list ')'
	{
	}
	| KW_VSIZE '(' exp ')'
	{
	}
	| KW_NULLIF '(' exp ',' exp ')'
     	{
	}
	| KW_EXTRACT '(' datepart_op KW_FROM exp ')'
	{
	}
	| KW_DATEPART '(' datepart_op ',' exp ')'
	{
	}
	| datead_fun '(' datepart_op ',' exp ',' exp ')'
	{
	}
	| exp KW_CONSTR_OP exp
     	{
	}
	| KW_SUBSTRING '(' exp KW_FROM exp ')'
	{
	}
	| KW_SUBSTRING '(' exp KW_FROM exp KW_FOR exp')'
	{
	}
	| KW_SUBSTRING '(' value_list ')'
     	{
	}
	| KW_REPEAT '(' exp ',' exp ')'
	{
	}
	| KW_REVERSE '(' exp ')'
	{
	}
	| decode_case
	{
	}
	| im_ex_cursor_name '%' KW_ROWCOUNT
	{
	}
	| KW_ROWNUM
	{
	}
	| global_var
	{
	}
	| '{' id exp '}'
	{
	}
	| '(' exp ')' interval_qualifier
	{
	}
	| id '(' exp ',' exp ')'
	{
	}
	| id '(' exp KW_IN exp ')'
	{
	}
	| KW_DATABASE '(' ')'
	{
	}
	| id '(' value_list_null ')'
	{
	}
;
	 
exp2 :
     	| '(' exp2 ')'
     	{
     	}
     	| '+' exp2 %prec UMINUS
     	{
     	}
     	| '-' exp2 %prec UMINUS
     	{
	}
 	| '~' exp2  
	{
	}
     	| lt_integer
     	{
     	}
     	| lt_binteger
     	{ 
     	}
     	| lt_decimal
     	{ 
     	}
     	| lt_real
     	{ 
     	}
     	| lt_string
     	{ 
     	}
     	| lt_bitstring
     	{ 
     	}
;

interval_qualifier_null :
    	{
    	}
    	| interval_qualifier
    	{
    	}
;

coalesce_value_list :
	exp
    	{
    	}
	| exp ',' coalesce_value_list
    	{
    	}
;

set_funs : 
	KW_AVG '(' all_distinct_option exp ')'
        {
        }
        | KW_COUNT '(' all_distinct_option exp ')'
        {
        }
        | KW_COUNT '(' '*' ')'
        {
        }
        | KW_MIN   '(' all_distinct_option exp ')'
        {
        }
        | KW_MAX   '(' all_distinct_option exp ')'
        {
        }
        | KW_SUM   '(' all_distinct_option exp ')'
        {
        }
;

funs : 
	qualified_name '('  ')'
    	{
    	}
	| qualified_name '(' value_list ')'
    	{
    	}
    	| qualified_name '(' '*' ')'
    	{
    	}
	| qualified_name '(' exp KW_IN exp ')'
	{
	}
;

decode_case :
	KW_DECODE '(' exp decode_when_list decode_else_exp_null ')'
    	{
    	}
;

decode_when_list :
    	',' exp ',' exp
    	{
    	}
    	| decode_when_list ',' exp ',' exp 
    	{
    	}
;

decode_else_exp_null :
    	{
    	}
	| ',' exp
    	{
    	}
;

simple_case :
	KW_CASE exp simple_when_list else_exp_null KW_END
    	{
    	}
;

simple_when_list :
    	KW_WHEN exp KW_THEN exp
    	{
    	}
    	| KW_WHEN exp KW_THEN exp simple_when_list
    	{
    	}
;

else_exp_null:
    	{
	}
	| KW_ELSE exp
    	{
    	}
;

boolean_case : 
	KW_CASE bool_when_list else_exp_null KW_END
	{
	}
;

bool_when_list :
    	KW_WHEN bool_exp KW_THEN exp
    	{
    	}
    	| KW_WHEN bool_exp KW_THEN exp bool_when_list
    	{
    	}
;

truth_value :
	KW_TRUE
    	{
	}
	| KW_FALSE
    	{
        }
;

ops : LP_OP
    	{        
    	}
    	| '='
    	{
    	}
    	| '>'
    	{
    	}
    	| '<'
    	{
    	}
;

value_list_null : 
	{
	}
	| exp_list
    	{       
    	}
;

value_list : 
	exp_list
    	{       
    	}
;

ins_value_list: 
	ins_exp_list
    	{
    	}
;

null_value :
	KW_NULL
    	{           
    	}
;

stm_param : 
	'?'
	{
	}
;

contains_exp :
	lt_string
	{
	}
	| contains_exp KW_AND contains_exp
    	{
    	}
	| contains_exp  KW_OR  contains_exp
    	{
        }
	| contains_exp KW_AND KW_NOT contains_exp
    	{
    	}
	| '(' contains_exp ')'
    	{
    	}
;

bool_exp :  
	KW_CONTAINS '('  qualified_name  ','  contains_exp ')'
	{
	}
	| bool_exp KW_AND bool_exp
    	{
	}
	| bool_exp KW_OR  bool_exp
    	{
    	}
	| KW_NOT bool_exp
    	{
        }
	| '(' bool_exp ')'
    	{
        }
	| exp not_tag KW_IN  '(' subquery ')'
    	{
	}
	| exp ops query_any_options '(' subquery ')'
    	{
        }
	| KW_EXISTS '(' subquery ')'
    	{
        }
	| exp not_tag KW_IN '(' value_list ')'
    	{
	}
	| exp ops exp
    	{
        }
	| exp KW_IS not_tag KW_NULL
    	{
	}
	| exp KW_BETWEEN exp KW_AND exp
	{
	}
	| exp KW_NOT KW_BETWEEN exp KW_AND exp
	{
	}
	| exp KW_LIKE exp
    	{
    	}
	| exp KW_LIKE exp '{' KW_ESCAPE exp '}'
    	{
	}
	| exp KW_LIKE exp KW_ESCAPE exp
    	{
        }
	| exp KW_NOT KW_LIKE exp
	{
	}
	| exp KW_NOT KW_LIKE exp KW_ESCAPE exp
    	{
	}
	| KW_TOO_MANY_ROWS
	{
	}
	| '(' exp ',' exp ')' KW_OVERLAPS '(' exp ',' exp ')' 
	{
        }
	| KW_INSERTING
	{
	}
	| KW_DELETING
	{
	}
	| KW_UPDATING
	{
	}
	| im_ex_cursor_name '%' KW_ISOPEN
	{
	}
	| im_ex_cursor_name '%' KW_FOUND
	{
	}
	| im_ex_cursor_name '%' KW_NOTFOUND
	{
	}
;

im_ex_cursor_name :
	KW_SQL
	{
	}
	| cursor_name
	{
	}
;

query_any_options :
	KW_ALL
    	{
    	}
	| KW_SOME
    	{
    	}
	| KW_ANY
    	{
    	}
;

/**************************************
	all kinds of name of object
***************************************/
global_var : 
	LT_GLOBAL_VAR
	{
	}
;

id :
	LT_IDENTIFIER
	{
	}
;

qualified_name :
	id
    	{
    	}
	| id '.' qualified_name 
    	{
    	}
;

variable_name : 
	id
    	{
    	}	
;

label_name : 
	id
    	{
    	}
;

database_name : 
	id
    	{
    	}
;

full_proc_name :
	qualified_name
    	{
    	}
;

full_table_name :
	qualified_name
    	{
    	}
;

table_name : 
	id
    	{
    	}
;

column_name : 
	id
    	{
    	}
;

constraint_name : 
	id
    	{
    	} 
;

full_trigger_name : 
	qualified_name
    	{
    	}
;

full_view_name : 
	qualified_name
	{
    	}
;

cursor_name : 
	id
    	{
    	} 
;

login_name : 
	id
    	{
	        $$ = $1;
    	}
;

user_name : id
    	{
    	}
;

role_name : 
	KW_CONNECT
	{
	}
	| id
	{
	}	
;

user_role_name : 
	qualified_name
    	{		
    	}
;

role_name_list :
	role_name
    	{
    	}
	| role_name_list ',' role_name
    	{
    	}
;

full_func_name : 
	qualified_name
    	{
    	}
;

param_name : 
	id
    	{
    	}
;

index_name : 
	id
    	{
    	}
;

trigger_name : 
	id
    	{
    	}
;

trig_old_name : 
	id
    	{
    	}
;

trig_new_name : id
    	{
    	}
;

full_tv_name : 
	qualified_name
    	{
    	}
;

full_object_name : 
	qualified_name
    	{
    	}
;

grant_object_name :
	qualified_name
    	{
    	}
	| qualified_name '(' column_list ')'
	{
	}
;

orient_option :
	KW_LEAD
	{
	}
	| KW_TRAIL
	{
	}
	| KW_BOTH
	{
	}
;


datepart : 
	LT_IDENTIFIER
	{
	}
;

datepart_op :
    	datepart
	{
	}
;
datead_fun :
	KW_DATEADD
	{
	}
	| KW_DATEDIFF
	{
	}
	| KW_TIMESTAMPADD
	{
	}
	| KW_TIMESTAMPDIFF
	{
	}	
;

savepoint_name : 
	id
    	{
    	}
;

alias :
	id
    	{
    	}
	| '[' id ']'
    	{
    	}
;

full_column_name : 
	qualified_name
    	{
    	}
;       

schema_name : 
	id
    	{
    	}
;


/********************************************************
	all kinds of tag of keyword which means that 
	the keyword exists or not
********************************************************/
not_tag :
    	{
	}
	| KW_NOT
    	{
    	}
;

debug_tag :
    	{
	}
	| KW_DEBUG
    	{
    	}
;

column_tag :
	{
	}
    	| KW_COLUMN
    	{
    	}
;

pendant_tag : 
    	{
	}
	| KW_PENDANT
    	{
    	}
;

unique_tag :
    	{
	}
	| KW_UNIQUE
    	{
    	}
	| KW_BITMAP
    	{
    	}
;

row_tag :
    	{
	}
	| KW_ROW
    	{
    	}
;

as_tag :
    	{
	}
	| KW_AS
    	{
    	}
;

from_tag :
   	{
	}
	| KW_FROM
    	{
    	}
;

into_tag :
    	{
	}
	| KW_INTO
    	{
    	}
;

work_tag : 
    	{
	}
	| KW_WORK
    	{
    	}
;

privileges_tag :
    	{
	}
	| KW_PRIVILEGES
    	{
    	}
;

grant_option_for_tag :
    	{
	}
	| KW_GRANT KW_OPTION KW_FOR
    	{
    	}
;

with_grant_option:
    	{
	}
	| KW_WITH KW_GRANT KW_OPTION
    	{
    	}
;


/*******************************************
 	others
**********************************/
endoption : 
    	{
	}
	| ';' 
	{
	}
;

datatype :
	dtype double_length_option
	{
	}
	| KW_INTERVAL interval_qualifier
	{
	}
;

interval_qualifier :
    	id double_length_option
    	{
    	}
    	|id double_length_option KW_TO id double_length_option
    	{
	}
;

dtype : 
	id
	{
		/*if (par_id_is_key($1, "CHAR"))
		{
		}
		else if (par_id_is_key($1, "CHARACTER"))
		{
		}
		else if (par_id_is_key($1, "VARCHAR"))
		{
		}
		else if (par_id_is_key($1, "VARCHAR2"))
		{
		}
		else if (par_id_is_key($1, "NUMERIC"))
		{
		}
		else if (par_id_is_key($1, "DECIMAL"))
		{
		}
		else if (par_id_is_key($1, "DEC"))
		{
		}
		else if (par_id_is_key($1, "BYTE"))
		{
		}
		else if (par_id_is_key($1, "TINYINT"))
		{
		}
		else if (par_id_is_key($1, "SMALLINT"))
		{
		}
		else if (par_id_is_key($1, "BIGINT"))
		{
		}
		else if (par_id_is_key($1, "INT"))
		{
		}
		else if (par_id_is_key($1, "INTEGER"))
		{
		}
		else if (par_id_is_key($1, "FLOAT"))
		{
		}
		else if (par_id_is_key($1, "REAL"))
		{
		}
		else if (par_id_is_key($1, "DOUBLE"))
		{
		}
		else if (par_id_is_key($1, "DATE"))
		{
		}
		else if (par_id_is_key($1, "TIME"))
		{
		}
		else if (par_id_is_key($1, "DATETIME"))
		{
		}
		else if (par_id_is_key($1, "TIMESTAMP"))
		{
		}
		else if (par_id_is_key($1, "TEXT"))
		{
		}
		else if (par_id_is_key($1, "CLOB"))
		{
		}
		else if (par_id_is_key($1, "SOUND"))
		{
		}
		else if (par_id_is_key($1, "IMAGE"))
		{
		}
		else if (par_id_is_key($1, "BINARY"))
		{
		}
		else if (par_id_is_key($1, "VARBINARY"))
		{
		}
		else if (par_id_is_key($1, "BLOB"))
		{
		}
		else if (par_id_is_key($1, "BIT"))
		{
		}
		else if (par_id_is_key($1, "MONEY"))
		{
		}
		else if (par_id_is_key($1, "LONGVARCHAR"))
		{
		}
		else if (par_id_is_key($1, "LONGVARBINARY"))
		{
		}
		else 
		{
			yyerror("data type");
		}*/
	}
	| id KW_VARYING
	{
		/*if (par_id_is_key($1, "CHAR"))
		{
		}
		else if (par_id_is_key($1, "CHARACTER"))
		{
		}
		else
		{
		   yyerror("varying");
		}*/
	}
	| id KW_PRECISION
	{
		/*if (par_id_is_key($1, "DOUBLE"))
		{
		}
		else
		{
		   yyerror("precision");
		}*/
	}
;

double_length_option:
	{
        }
	|'(' lt_integer ')'
        {
        }
        |'(' lt_integer ',' lt_integer ')'
        {
        }
;

lt_binteger : 
	LT_BINTEGER 
    	{
        }
;

lt_integer : 
	LT_INTEGER
    	{
	}
;

lt_decimal :
	LT_DECIMAL
    	{
        }
;

lt_string :
	LT_STRING
    	{
	}
;

lt_bitstring :
	LT_BITSTRING
    	{
    	}
;

lt_real :
	LT_REAL
    	{
    	}
;

create_contextindex_stmt :
	KW_CREATE KW_CONTEXT KW_INDEX index_name KW_ON full_table_name '(' index_column_name ')' 
    	{
    	}
	| KW_CREATE KW_CONTEXT KW_INDEX index_name KW_ON full_table_name '(' index_column_name ')' KW_SYNC
	{
	}
;

drop_contextindex_stmt :
	KW_DROP KW_CONTEXT KW_INDEX index_name KW_ON full_table_name
    	{
	}
;

alter_contextindex_stmt :
	KW_ALTER KW_CONTEXT KW_INDEX index_name KW_ON full_table_name KW_REBUILD
	{
	}
	| KW_ALTER KW_CONTEXT KW_INDEX index_name KW_ON full_table_name KW_INCREMENT
	{
	}
;


/*******************************
	not complete yet
********************************/


%%

public ParserError par_error = null;
public ParserSqlList par_sql_lst = null;
public ParserSqlWordList sqlword_lst = null;
public int sqlType = DmdbConnection.SQL_TYPE_UNKNOWN;

long yyerror(String s)
{
    /*par_error_node_t*  pe = NULL;

	
	pe = mem_heap_alloc(par_heap, sizeof(par_error_node_t));

	if (file_name == NULL)
		pe->file = NULL;
	else
	    pe->file = mem_heap_strdup(par_heap, file_name);

	if (lexer.lex_token.token == 0)
	{
	    pe->errcode = lex_error.errcode;
		pe->lineno  = yylineno;
		pe->yytext  = mem_heap_strdup(par_heap, lex_error.errmsg);
	}
	else
	{
		pe->errcode = EC_PARSE_ERROR;
		pe->lineno  = yylineno;
		pe->yytext  = mem_heap_strdup(par_heap, yytext);
	}
	
	DM_LIST_ADD_LAST(link, par_error, pe);

	return 0;*/
	
	if (par_error == null)
	    par_error = new ParserError();

	if (lexer.lex_token.token == 0)
	{
		par_error.addErrorInfo(/*file_name*/"", lexer.yyline, lexer.lex_error.errmsg, lexer.lex_error.errcode);
	}
	else
	{
		par_error.addErrorInfo(
                        /*file_name*/"",
                        lexer.yyline, 
                        (String)sqlword_lst.sqlWordList.get(sqlword_lst.sqlWordList.size() - 1),
                        LexToken.EC_PARSE_ERROR);	
                       }

	return 0;
}

/*dmbool
readsql(String s)
{
    char tmps[1000];

    strcpy(s, "");
    while (true)
    {
        gets(tmps);
        if (strcmp(tmps, "go") == 0)
           return true;
        else if (strcmp(tmps, "###") == 0)
            return false;
        else
        {
            strcat(s, tmps);
            strcat(s, "\n");
        }
    }
}
*/


/*
main()
{
    lex_init();

    while (true)
    {

       char s[4000];

       if (readsql(s))
       {
           //lex_scaner_init(s);
           yyparse();
           //lex_scaner_deinit();
       }
       else
          break;
    }

    lex_deinit();
}
*/




/*void*
paralloc(unsigned long size)
{
    return mem_heap_alloc(par_heap, size);
}*/


/*
unsigned long
par_get_size(long par_kind)
{
    switch (par_kind)
    {
        case PAR_DMPROGRAM : return sizeof(par_dmprogram_t);
        case PAR_ID : return sizeof(par_id_t);

        default:  return 0; //temp??
    }
        
}*/
  
private Yylex lexer;

private int yylex () {
	int yyl_return = -1;
	try {
		yylval = new ParserVal(0);
		yyl_return = lexer.yylex();
	}
	catch (IOException e) {
		System.err.println("IO error :"+e);
	}
	return yyl_return;
}

public Parser(Reader r) {
  initParser();
  lexer = new Yylex(r, this);
}

/*public static void main()
{
	Parser yyparser;
    	if ( args.length > 0 ) {
	      yyparser = new Parser(new FileReader(args[0]));
    	}
    	
    	yyparser.parse_it("select * from systables;");
}*/

/*******************************************************************
name:
    parse_it
purpose:
    parse the source SQL statement to build the grammar-tree
notes:
    the par_heap should be freed by mem_heap_free by the caller
********************************************************************/
public
long
parse_it(
	Reader r
)
{
        lexer = new Yylex(r, this);
	
	par_error = null;

	lexer.yyline = 1;

    	yyparse();

	if (par_error == null)
		return 0;
	return par_error.getErrorNodeNum();
}

/*******************************************************************
name:
    parse_init
purpose:
    to initialize the SQL-parser system on system startup
********************************************************************/
public
void
parser_init()
{
	par_sql_lst = null;
	sqlword_lst = null;
	sqlword_lst = null;
	LexKeyW.LexInit();
}

/*******************************************************************
name:
    parse_deinit
purpose:
    to de-initialize the SQL-parser system on system shutdown
********************************************************************/
public
void
parser_deinit()
{
	if (par_sql_lst != null)
    		par_sql_lst.clearSqlList();
  	if (sqlword_lst != null)
    		sqlword_lst.clearSqlWordList();
  	if (par_error != null)
    		par_error.clearErrorList();
}

/***************************************************************
name:
	par_add_sql
purpose:
	add a sql string to sql list
****************************************************************/
void
par_add_sql(boolean keep_last, String lgn, String pwd, String db)
{
	String str = lexer.lex_rec_sql();

	if (par_sql_lst == null)
		par_sql_lst = new ParserSqlList();
	
	par_sql_lst.AddSql(str, sqlType, sqlword_lst.sqlWordList, sqlword_lst.sqlWordPos);
        
	sqlType = DmdbConnection.SQL_TYPE_UNKNOWN;
        sqlword_lst.clearSqlWordList();
}

void
sqlword_lst_add(
        String				sword,
        int                             pos
)
{
	if (sqlword_lst == null)
		sqlword_lst = new ParserSqlWordList();
        sqlword_lst.addSqlWord(sword, pos);
}

public void initParser() {
  	int i, count, curPos;

	//ʼyylhs
  	count = ParserConst.yylhs.length;
  	yylhs = new short [count];
  	for (i = 0; i < count; i++)
  	{
    		yylhs[i] = ParserConst.yylhs[i];
  	}

  	//ʼyylen
  	count = ParserConst.yylen.length;
  	yylen = new short [count];
  	for (i = 0; i < count; i++)
  	{
    		yylen[i] = ParserConst.yylen[i];
  	}

  	//ʼyydefred
  	count = ParserConst.yydefred.length;
  	yydefred = new short [count];
  	for (i = 0; i < count; i++)
  	{
    		yydefred[i] = ParserConst.yydefred[i];
  	}

  	//ʼyydgoto
  	count = ParserConst.yydgoto.length;
  	yydgoto = new short [count];
  	for (i = 0; i < count; i++)
  	{
    		yydgoto[i] = ParserConst.yydgoto[i];
  	}

  	//ʼyysindex
  	count = ParserConst.yysindex.length;
  	yysindex = new short [count];
  	for (i = 0; i < count; i++)
  	{
    		yysindex[i] = ParserConst.yysindex[i];
  	}

  	//ʼyyrindex
  	count = ParserConst.yyrindex.length;
  	yyrindex = new short [count];
  	for (i = 0; i < count; i++)
  	{
    		yyrindex[i] = ParserConst.yyrindex[i];
  	}

  	//ʼyygindex
  	count = ParserConst.yygindex.length;
  	yygindex = new short [count];
  	for (i = 0; i < count; i++)
  	{
    		yygindex[i] = ParserConst.yygindex[i];
  	}

  	//ʼyytable
  	count = ParserConst2.yytable.length + ParserConst3.yytable.length +
          		ParserConst4.yytable.length + ParserConst5.yytable.length;
  	yytable = new short [count];

  	curPos = 0;
  	count = ParserConst2.yytable.length;
  	for (i = 0; i < count; i++)
  	{
    		yytable[curPos++] = ParserConst2.yytable[i];
  	}

  	count = ParserConst3.yytable.length;
  	for (i = 0; i < count; i++)
  	{
    		yytable[curPos++] = ParserConst3.yytable[i];
  	}

  	count = ParserConst4.yytable.length;
  	for (i = 0; i < count; i++)
  	{
    		yytable[curPos++] = ParserConst4.yytable[i];
  	}

  	count = ParserConst5.yytable.length;
  	for (i = 0; i < count; i++)
  	{
    		yytable[curPos++] = ParserConst5.yytable[i];
  	}

  	//ʼyycheck
  	count = ParserConst6.yycheck.length + ParserConst7.yycheck.length +
          	ParserConst8.yycheck.length + ParserConst9.yycheck.length;
  	yycheck = new short [count];
	
  	curPos = 0;
  	count = ParserConst6.yycheck.length;
  	for (i = 0; i < count; i++)
  	{
    		yycheck[curPos++] = ParserConst6.yycheck[i];
  	}

  	count = ParserConst7.yycheck.length;
  	for (i = 0; i < count; i++)
  	{
    		yycheck[curPos++] = ParserConst7.yycheck[i];
  	}

  	count = ParserConst8.yycheck.length;
  	for (i = 0; i < count; i++)
  	{
    		yycheck[curPos++] = ParserConst8.yycheck[i];
  	}

  	count = ParserConst9.yycheck.length;
  	for (i = 0; i < count; i++)
  	{
    		yycheck[curPos++] = ParserConst9.yycheck[i];
  	}
}

public int getSqlNum()
{
  	return par_sql_lst.sqlList.size();
}

public int getSqlType(int nth)
{
  	return par_sql_lst.getSqlType(nth);
}

public String getSql(int nth)
{
  	return par_sql_lst.getSql(nth);
}

public String[] getSqlWordList(int nth)
{
  	Vector vc = par_sql_lst.getSqlWordList(nth);
  	String[] wordList = new String[vc.size()];

	for (int i = 0; i < vc.size(); i++)
  	{
    		wordList[i] = (String)vc.get(i);
  	}
  	
  	return wordList;
}

public int[] getSqlWordPos(int nth)
{
  	Vector vc = par_sql_lst.getSqlWordPos(nth);
  	int[] wordPos = new int[vc.size()];

  	for (int i = 0; i < vc.size(); i++)
  	{
    		wordPos[i] = ((Integer)vc.get(i)).intValue();
  	}
  	
  	return wordPos;
}

public int getParseErrNum()
{
  	if (par_error == null)
    		return 0;
  	
  	return par_error.getErrorNodeNum();
}

public String getParseErrInfo(int nth)
{
  	return par_error.getErrInfo(nth);
}

